function [x,iter]=myfsolve(x,nmax,toll,fun,varargin)
iter = 0;     
err  = 1;
fk = feval(fun,x,varargin{:});
n = max(size(fk));
Q = eye(n);
while iter < nmax & err > toll
    s=-Q\fk;
    x=s+x; 
    err=norm(s,inf);
    if err > toll
        fk1 = feval(fun,x,varargin{:});
    end
    Q=Q+1/(s'*s)*fk1*s';
    iter = iter + 1; 
    fk=fk1;
end
return